<?php

if ($_SERVER['REQUEST_METHOD'] == "HEAD") {
 
  header("Content-Type: video/x-flv");

} else {

  if (file_exists('/conf/config')) {
    $config = file_get_contents('/conf/config');
    if(preg_match('/MEGA_AUTH=\'(.+)\'/', $config, $config_result)) {
      $auth = $config_result[1];
    }
  }

  $xmlMegavideo = file_get_contents("http://www.megavideo.com/xml/videolink.php?v=" . $_GET['id'] . "&id=" . time());
  preg_match('/ s="(.*?)"/',$xmlMegavideo,$server);
  preg_match('/ k1="(.*?)"/',$xmlMegavideo,$key1);
  preg_match('/ k2="(.*?)"/',$xmlMegavideo,$key2);
  preg_match('/ un="(.*?)"/',$xmlMegavideo,$hash);

  $url = "http://www" . $server[1] . ".megavideo.com/files/" . decrypt($hash[1],$key1[1],$key2[1]) . "/";
  $parsedURL = parse_url($url);
  $prmHost = $parsedURL['host'];
  $prmPath = $parsedURL['path'];
   
  $fp = fsockopen($prmHost, 80, $errno, $errstr, 30);
  if (!$fp) {
    echo "$errstr ($errno)<br />\n";
  } else {
    $out  = "GET " . $prmPath . " HTTP/1.1" . "\r\n";
    $out .= "User-Agent: Wget/1.12 (elf)" . "\r\n";
    $out .= "Host: " . $prmHost . "\r\n";
    $out .= "Cache-Control: no-cache" . "\r\n";
    if ($_SERVER['HTTP_RANGE']) {
      $out .= "Range: " . $_SERVER['HTTP_RANGE'] . "\r\n";
    }
    if ($auth) {
      $out .= "Cookie: user=" . $auth . "\r\n";
    }
    $out .= "Connection: Close"."\r\n"."\r\n";
    fwrite($fp, $out);
    $headerpassed = false;
     while ($headerpassed == false) {
        $line = fgets($fp);
        if((stristr($line, 'Content-Type')) || (stristr($line, 'Content-Length'))) {
           header($line);
        }
        if( $line == "\r\n" ) {
           $headerpassed = true;
        }
     }
     fpassthru($fp);
     fclose($fp);
  }
}

# decrypt function from megavideo.class.php by luruke

function decrypt($str, $key1, $key2) {
  $reg1 = array();
 
  for($reg3=0; $reg3<strlen($str); $reg3++) {
    $reg0 = $str[$reg3];                 
    switch($reg0) {
      case '0': $reg1[] = '0000'; break;
      case '1': $reg1[] = '0001'; break;
      case '2': $reg1[] = '0010'; break;
      case '3': $reg1[] = '0011'; break;
      case '4': $reg1[] = '0100'; break;
      case '5': $reg1[] = '0101'; break;
      case '6': $reg1[] = '0110'; break;
      case '7': $reg1[] = '0111'; break;
      case '8': $reg1[] = '1000'; break;
      case '9': $reg1[] = '1001'; break;
      case 'a': $reg1[] = '1010'; break;
      case 'b': $reg1[] = '1011'; break;
      case 'c': $reg1[] = '1100'; break;
      case 'd': $reg1[] = '1101'; break;
      case 'e': $reg1[] = '1110'; break;
      case 'f': $reg1[] = '1111'; break;
    }
  }
               
  $reg1 = join($reg1);
  $reg6 = array();
               
  for($reg3=0; $reg3<384; $reg3++) {
    $key1 = ($key1 * 11 + 77213) % 81371;
    $key2 = ($key2 * 17 + 92717) % 192811;
    $reg6[] = ($key1 + $key2) % 128;
  }
               
  for($reg3=256; $reg3>=0; $reg3--) {
    $reg5 = $reg6[$reg3];
    $reg4 = $reg3 % 128;
    $reg8 = $reg1[$reg5];
    $reg1[$reg5] = $reg1[$reg4];
    $reg1[$reg4] = $reg8;
  }
               
  for($reg3=0; $reg3<128; $reg3++) {
    $reg1[$reg3] = $reg1[$reg3] ^ ($reg6[$reg3+256] & 1);   
  }
               
  $reg12 = $reg1;
  $reg7 = array();
               
  for($reg3=0; $reg3<strlen($reg12); $reg3+=4) {
    $reg9 = substr($reg12, $reg3, 4);
    $reg7[] = $reg9;
  }
               
  $reg2 = array();
               
  for($reg3=0; $reg3<count($reg7); $reg3++) {
    $reg0 = $reg7[$reg3];
    switch($reg0) {
      case '0000': $reg2[] = '0'; break;
      case '0001': $reg2[] = '1'; break;
      case '0010': $reg2[] = '2'; break;
      case '0011': $reg2[] = '3'; break;
      case '0100': $reg2[] = '4'; break;
      case '0101': $reg2[] = '5'; break;
      case '0110': $reg2[] = '6'; break;
      case '0111': $reg2[] = '7'; break;
      case '1000': $reg2[] = '8'; break;
      case '1001': $reg2[] = '9'; break;
      case '1010': $reg2[] = 'a'; break;
      case '1011': $reg2[] = 'b'; break;
      case '1100': $reg2[] = 'c'; break;
      case '1101': $reg2[] = 'd'; break;
      case '1110': $reg2[] = 'e'; break;
      case '1111': $reg2[] = 'f'; break;
    }
  }
           
  return join($reg2);
                     
}
?>
