<?php

function _pluginMain($prmQuery) {
$queryData = array();
parse_str($prmQuery, $queryData);
if ($queryData['category_url'] !='') {
$items = _pluginCreateMovieItems($queryData['category_url'],10);
return $items;
} elseif ($queryData['movie_url'] !='') {
$items = _pluginCreateVideoItems($queryData['movie_url']);
return $items;
} else {
$items = _pluginCreateCategoryList();
return $items;
}
}

function _pluginCreateCategoryList() {
$categories = array(
'Acci&oacute;n' => 'peliculas-de-accion',
'Manga' => 'peliculas-de-anime-manga',
'Artes Marciales' => 'peliculas-de-artes-marciales',
'Aventura' => 'peliculas-de-aventura',
'Biogr&aacute;fica' => 'peliculas-biograficas',
'Ciencia Ficci&oacute;n' => 'peliculas-de-ciencia-ficcion',
'Comedia' => 'peliculas-de-comedia',
'Cortometrajes' => 'cortometrajes',
'Deportes' => 'peliculas-de-deporte',
'Dibujos animadoa' => 'peliculas-de-dibujos',
'Documentales' => 'documentales',
'Drama' => 'peliculas-de-drama',
'Fantas&iacute;a' => 'peliculas-de-fantasia',
'Guerra / B&eacute;licas' => 'peliculas-de-guerra',
'Infantil' => 'peliculas-infantiles',
'Intriga' => 'peliculas-de-intriga',
'Miedo / Terror' => 'peliculas-de-miedo',
'Musicales' => 'musicales',
'Rom&aacute;nticas' => 'peliculas-romanticas',
'Suspense' => 'peliculas-de-suspense',
'Thriller' => 'peliculas-de-thriller',
'Western' => 'peliculas-western'
);

foreach ($categories as $name => $id) {
$url = "http://www.peliculas21.com/" . $id . "/";

$data = array(
'category_url' => $url
);
$dataString = http_build_query($data, 'pluginvar_');
$retMediaItems[] = array (
'id' => 'umsp://plugins/peliculas21?' . $dataString,
'dc:title' => html_entity_decode($name,0,"UTF-8"),
'upnp:class' => 'object.container',
);
}
return $retMediaItems;
}

function _pluginCreateMovieItems($url,$pageCount) {

for ($i = 1; $i <= $pageCount; $i++) {

$html = file_get_contents($url . $i . "/");
preg_match_all('/<span class="titulotool"><strong>(.*?)<\/strong><\/span>/',$html,$title);

if (empty($title[1])) break;

preg_match_all('/src="(.*?)" width="/',$html,$poster);
preg_match_all('/<a href="(.*)" target="_blank" >/',$html,$link);

for ($z = 0; $z < sizeof($title[1]); $z++) {
$data = array(
'movie_url' => "http://www.peliculas21.com" . $link[1][$z]
);
$dataString = http_build_query($data, 'pluginvar_');
$retMediaItems[] = array (
'id' => 'umsp://plugins/peliculas21?' . $dataString,
'dc:title' => html_entity_decode($title[1][$z],0,"UTF-8"),
'upnp:album_art'=> "http://www.peliculas21.com" . $poster[1][$z],
'upnp:class' => 'object.container',
);
}
}
return $retMediaItems;
}

function _pluginCreateVideoItems($url) {
$html = file_get_contents($url);

preg_match_all('/<a href="http:\/\/www.megavideo.com\/\?v=(.*?)" target/',$html,$megavid);
preg_match('/<h1 class="peliculatitulo">(.*?)<\/h1>/',$html,$title);

if (file_exists('/conf/config')) {
$config = file_get_contents('/conf/config');
if(preg_match('/MEGA_AUTH=\'(.+)\'/', $config, $config_result)) {
$auth = $config_result[1];
preg_match_all('/<a href="http:\/\/www.megaupload.com\/\?d=(.*?)"/',$html,$megaup);
}
}


for ($z = 0; $z < sizeof($megavid[1]); $z++) {
$retMediaItems[] = array (
'id' => 'umsp://plugins/peliculas21?' . $megavid[1][$z],
'dc:title' => html_entity_decode($title[1],0,"UTF-8") . " (Megavideo #" . ($z+1) . ")",
'res' => "http://localhost/umsp/plugins/megavideo-proxy.php?id=" . $megavid[1][$z],
'upnp:class' => 'object.item.videoitem',
'protocolInfo' => '*:*:*:*'
);
}

for ($z = 0; $z < sizeof($megaup[1]); $z++) {
$opts = array(
'http' => array(
'method' => "HEAD",
'max_redirects' => '0',
'header' => 'Cookie: user=' . $auth . "\r\n"
)
);
$context = stream_context_create($opts);

$getHeaders = @file_get_contents("http://www.megaupload.com/?d=" . $megaup[1][$z], false, $context);

if (preg_match('/location: (.+)/',$http_response_header[3],$res)) {
$retMediaItems[] = array (
'id' => 'umsp://plugins/peliculas21?' . $id[1][$i],
'dc:title' => html_entity_decode($title[1],0,"UTF-8") . " (Megaupload #" . ($z+1) . ")",
'res' => $res[1],
'upnp:class' => 'object.item.videoitem',
'protocolInfo' => '*:*:*:*'
);
}
}

return $retMediaItems;
}

?>