        <?php

    function _pluginMain($prmQuery) {
    $queryData = array();
    parse_str($prmQuery, $queryData);
    if ($queryData['category_url'] !='') {
    $items = _pluginCreateMovieItems($queryData['category_url']);
    return $items;
    } elseif ($queryData['movie_url'] !='') {
    $items = _pluginCreateTempList($queryData['movie_url']);
    return $items;
    } elseif ($queryData['temp_url'] !='') {
    $items = _pluginCreateCapList($queryData['temp_url']);
    return $items;
    } elseif ($queryData['cap_url'] !='') {
    $items = _pluginCreateVideoItems($queryData['cap_url']);
    return $items;
    } else {
    $items = _pluginCreateCategoryList();
    return $items;
    }
    }

    function _pluginCreateCategoryList() {
    $categories = array(
    '0-9' => 'lista-series-num',
    'A' => 'lista-series-a',
    'B' => 'lista-series-b',
    'C' => 'lista-series-c',
    'D' => 'lista-series-d',
    'E' => 'lista-series-e',
    'F' => 'lista-series-f',
    'G' => 'lista-series-g',
    'H' => 'lista-series-h',
    'I' => 'lista-series-i',
    'J' => 'lista-series-j',
    'K' => 'lista-series-k',
    'L' => 'lista-series-l',
    'M' => 'lista-series-m',
    'N' => 'lista-series-n',
    'O' => 'lista-series-o',
    'P' => 'lista-series-p',
    'Q' => 'lista-series-q',
    'R' => 'lista-series-r',
    'S' => 'lista-series-s',
    'T' => 'lista-series-t',
    'U' => 'lista-series-u',
    'V' => 'lista-series-v',
    'W' => 'lista-series-w',
    'X' => 'lista-series-x',
    'Y' => 'lista-series-y',
    'Z' => 'lista-series-z',
    );
    foreach ($categories as $name => $id) {
    $url = "http://www.seriespepito.com/" . $id . "/";
    $data = array(
    'category_url' => $url
    );
    $dataString = http_build_query($data, 'pluginvar_');
    $retMediaItems[] = array (
    'id' => 'umsp://plugins/seriespepito?' . $dataString,
    'dc:title' => html_entity_decode($name,0,"UTF-8"),
    'upnp:class' => 'object.container',
    );
    }
    return $retMediaItems;
    }

    function _pluginCreateMovieItems($url) {

    $html = file_get_contents($url);
    preg_match_all("/class='img' \/><br \/>(.*?)<\/a>/",$html,$title);

    if (empty($title[1])) break;
    preg_match_all("/<img src='(.*?)' width='110'/",$html,$poster);
    preg_match_all('/<a class="azulverde" href="(.*?)" title/',$html,$link);

    for ($z = 0; $z < sizeof($title[1]); $z++) {
    $data = array(
    'movie_url' => $link[1][$z]
    );
    $dataString = http_build_query($data, 'pluginvar_');
    $retMediaItems[] = array (
    'id' => 'umsp://plugins/seriespepito?' . $dataString,
    'dc:title' => html_entity_decode($title[1][$z],0,"UTF-8"),
    'upnp:album_art'=> $poster[1][$z],
    'upnp:class' => 'object.container',
    );
    }
    return $retMediaItems;
    }

    function _pluginCreateTempList($url) {
    $html = file_get_contents($url);
    preg_match_all("/<a class='blanco' href='(.*?)' title=/",$html,$link);

    for ($z = 0; $z < sizeof($link[1]); $z++) {
    $data = array(
    'temp_url' => $link[1][$z]
    );
    $count = $z + 1;
    $title = 'Temporada ' . $count;
    $dataString = http_build_query($data, 'pluginvar_');
    $retMediaItems[] = array (
    'id' => 'umsp://plugins/seriespepito?' . $dataString,
    'dc:title' => html_entity_decode($title,0,"UTF-8"),
    'upnp:class' => 'object.container', 
    );
    }
    return $retMediaItems;
    }

    function _pluginCreateCapList($url) {

    $html = file_get_contents($url);
    preg_match_all("/<a class='capitulo1' href='(.*?)' title='(.*?)'/",$html,$link);

    for ($z = 0; $z < sizeof($link[1]); $z++) {
    $data = array(
    'cap_url' => $link[1][$z]
    );
    $count = $z + 1;
    $title = 'Capitulo ' . $count;
    $dataString = http_build_query($data, 'pluginvar_');
    $retMediaItems[] = array (
    'id' => 'umsp://plugins/seriespepito?' . $dataString,
    'dc:title' => html_entity_decode($title,0,"UTF-8"),
    'upnp:class' => 'object.container', 
    );
    }
    return $retMediaItems;
    }

    function _pluginCreateVideoItems($url) {
    $html = file_get_contents($url);

    preg_match_all("/href='http:\/\/www.megavideo.com\/\?(.*?)=(.*?)'/",$html,$megavid);
    preg_match('/span class="tam12">(.*?)<\/span>/',$html,$title);

    if (file_exists('/conf/config')) {
    $config = file_get_contents('/conf/config');
    if(preg_match('/MEGA_AUTH=\'(.+)\'/', $config, $config_result)) {
    $auth = $config_result[1];
    preg_match_all("/href='http:\/\/www.megaupload.com\/\?(.*?)=(.*?)'/",$html,$megaup);
    }
    }

    for ($i = 0; $i < sizeof($megavid[2]); $i++) {
    $part = (sizeof($megavid[2]) > 1) ? "/" . ($i+1) : "";
    $retMediaItems[] = array (
    'id' => 'umsp://plugins/seriespepito?' . $megavid[2][$i],
    'dc:title' => html_entity_decode($title[1],0,"UTF-8") . " (Megavideo #" . ($z+1) . $part . ")",
    'res' => "http://localhost/umsp/plugins/megavideo-proxy.php?id=" . $megavid[2][$i],
    'upnp:class' => 'object.item.videoitem',
    'protocolInfo' => '*:*:*:*'
    );
    }


    $opts = array(
    'http' => array(
    'method' => "HEAD",
    'max_redirects' => '0',
    'header' => 'Cookie: user=' . $auth . "\r\n"
    )
    );
    $context = stream_context_create($opts);

    for ($i = 0; $i < sizeof($megaup[2]); $i++) {
    $getHeaders = @file_get_contents("http://www.megaupload.com/?" .$megaup[1][$i] . "=" . $megaup[2][$i], false, $context);

    if (preg_match('/location: (.+)/',$http_response_header[3],$res)) {
    $part = (sizeof($megaup[2]) > 1) ? "/" . ($i+1) : "";
    $retMediaItems[] = array (
    'id' => 'umsp://plugins/seriespepito?' . $megaup[2][$i],
    'dc:title' => html_entity_decode($title[1],0,"UTF-8") . " (Megaupload #" . ($z+1) . $part . ")",
    'res' => $res[1],
    'upnp:class' => 'object.item.videoitem',
    'protocolInfo' => '*:*:*:*'
    );
    }

    }   
    return $retMediaItems;
    }
    ?>