    <?php
    function unescape($cadena_entrada)
    {
       $cadena_salida="";
       $longitud=strlen($cadena_entrada);
       if(($longitud%3)==0)
          for($i=0; $i<$longitud; $i+=3) $cadena_salida.=chr(hexdec(substr($cadena_entrada,$i+1,2)));
       return $cadena_salida;
    }

    function decodificar($cadena_entrada) {
        $cadena_salida="";
        $longitud=strlen($cadena_entrada);
        $d = 141;
        $f = 0;
        for($i=0; $i<$longitud; $i++)
        {
           $f = $d ^ ord(substr($cadena_entrada,$i,1));
           if ($i == $longitud-1) $f -= 7;
           else if ($i > 0) $f -= ($i * 2) + 2;
          $cadena_salida.= chr($f);
            $d += $i + 1;
       }
        return $cadena_salida;
    }

    function decoMegaup($cadena_entrada) {
       $cadena_salida="";
        $longitud=strlen($cadena_entrada);
        $d = 254;
        $f = 0;
        for($i=0; $i<$longitud; $i++)
        {
           $f = $d ^ ord(substr($cadena_entrada,$i,1));
          $cadena_salida.= chr($f);
       }
        return $cadena_salida;
    }

    function _pluginMain($prmQuery) {
      $queryData = array();
      parse_str($prmQuery, $queryData);
      if ($queryData['category_url'] !='') {
        $items = _pluginCreateMovieItems($queryData['category_url']);
        return $items;
      } elseif ($queryData['movie_url'] !='') {
        $items = _pluginCreateTempList($queryData['movie_url']);
        return $items;
      } elseif ($queryData['temp_url'] !='') {
        $items = _pluginCreateCapList($queryData['temp_url']);
        return $items;
      } elseif ($queryData['cap_url'] !='') {
        $items = _pluginCreateVideoItems($queryData['cap_url']);
        return $items;
      } else {
      $items = _pluginCreateCategoryList();
      return $items;
      }
    }

    function _pluginCreateCategoryList() {
      $categories = array(
        '0-9' => 'listaSeriesNumeric.php',
        'A' => 'listaSeriesA.php',
        'B' => 'listaSeriesB.php',
        'C' => 'listaSeriesC.php',
        'D' => 'listaSeriesD.php',
        'E' => 'listaSeriesE.php',
        'F' => 'listaSeriesF.php',
        'G' => 'listaSeriesG.php',
        'H' => 'listaSeriesH.php',
        'I' => 'listaSeriesI.php',
        'J' => 'listaSeriesJ.php',
        'K' => 'listaSeriesK.php',
        'L' => 'listaSeriesL.php',
        'M' => 'listaSeriesM.php',
        'N' => 'listaSeriesN.php',
        'O' => 'listaSeriesO.php',
        'P' => 'listaSeriesP.php',
        'Q' => 'listaSeriesQ.php',
        'R' => 'listaSeriesR.php',
        'S' => 'listaSeriesS.php',
        'T' => 'listaSeriesT.php',
        'U' => 'listaSeriesU.php',
        'V' => 'listaSeriesV.php',
        'W' => 'listaSeriesW.php',
        'X' => 'listaSeriesX.php',
        'Y' => 'listaSeriesY.php',
        'Z' => 'listaSeriesZ.php',
      );
      foreach ($categories as $name => $id) {
        $url = "http://www.seriesyonkis.com/lista-series/" . $id ;
        $data = array(
          'category_url' => $url
        );
        $dataString = http_build_query($data, 'pluginvar_');
        $retMediaItems[] = array (
          'id' => 'umsp://plugins/seriesyonkis?' . $dataString,
          'dc:title' => html_entity_decode($name,0,"UTF-8"),
          'upnp:class' => 'object.container',
        );
      }
      return $retMediaItems;
    }

    function _pluginCreateMovieItems($url) {
       $html = file_get_contents($url);
        preg_match_all("/<center><a title='(.*?)' href='(.*?)'><img src='(.*?)' alt=/",$html,$title);
        if (empty($title[1])) break;
        for ($z = 0; $z < sizeof($title[1]); $z++) {
          $data = array(
            'movie_url' => $title[2][$z]
          );
          $dataString = http_build_query($data, 'pluginvar_');
          $retMediaItems[] = array (
            'id' => 'umsp://plugins/seriesyonkis?' . $dataString,
            'dc:title' => html_entity_decode($title[1][$z],0,"UTF-8"),
            'upnp:album_art'=> $title[3][$z],
            'upnp:class' => 'object.container',
          );
        }
      return $retMediaItems;
    }

    function _pluginCreateTempList($url) {
       $html = file_get_contents($url);
       preg_match_all('/<li class="page_item"><h4><a href="(.*?)" title=/',$html,$link);
       for ($z = 0; $z < sizeof($link[1]); $z++) {
          $data = array(
          'temp_url' => $link[1][$z]
          );
          $count = $z + 1;
          $title = 'Temporada ' . $count. ' ' . $link[1][$z] ;
          $dataString = http_build_query($data, 'pluginvar_');
          $retMediaItems[] = array (
           'id' => 'umsp://plugins/seriesyonkis?' . $dataString,
             'dc:title' => html_entity_decode($title,0,"UTF-8"),
             'upnp:class' => 'object.container',
          );
       }
       return $retMediaItems;
    }

    function _pluginCreateCapList($url) {
       $html = file_get_contents($url);
       preg_match_all('/<h5><a href="(.*?)" title="(.*?)"/',$html,$link);
       
       for ($z = 0; $z < sizeof($link[1]); $z++) {
          $data = array(
          'cap_url' => $link[1][$z]
           );
           $dataString = http_build_query($data, 'pluginvar_');
           $retMediaItems[] = array (
             'id' => 'umsp://plugins/seriesyonkis?' . $dataString,
           'dc:title' => html_entity_decode($link[2][$z],0,"UTF-8"),
             'upnp:class' => 'object.container',
       );
       }
       return $retMediaItems;
    }

    function _pluginCreateVideoItems($url) {
      $html = file_get_contents($url);
      preg_match_all('/alt="Megavideo" (.*?) href="(.*?)&id=(.*?)" target="peli">/',$html,$megavid);
      preg_match('/<title>(.*?)</title><link/',$html,$title);

      if (file_exists('/conf/config')) {
        $config = file_get_contents('/conf/config');
        if(preg_match('/MEGA_AUTH=\'(.+)\'/', $config, $config_result)) {
          $auth = $config_result[1];
          preg_match_all('/id=(.*?)" title="Descargar archivo"/',$html,$megaup);
        }
      }
        for ($i = 0; $i < sizeof($megavid[3]); $i++) {
          $part = (sizeof($megavid[3]) > 1) ? "/" . ($i+1) : "";
          $auxiliar = decodificar(unescape($megavid[3][$i]));
          $retMediaItems[] = array (
            'id' => 'umsp://plugins/seriesyonkis?' . $auxiliar,
            'dc:title' => html_entity_decode($title[1],0,"UTF-8") . " (Megavideo #" . ($z+1) . $part . ")",
            'res' => "http://localhost/umsp/plugins/megavideo-proxy.php?id=" . $auxiliar,
            'upnp:class' => 'object.item.videoitem',
            'protocolInfo' => '*:*:*:*'
          );
        }
        $opts = array(
          'http' => array(
            'method' => "HEAD",
            'max_redirects' => '0',
            'header' => 'Cookie: user=' . $auth . "\r\n"
          )
        );
        $context = stream_context_create($opts);
        for ($i = 0; $i < sizeof($megaup[2]); $i++) {
          $auxiliar = decoMegaup(unescape($megaup[2][$i]));
          $getHeaders = @file_get_contents("http://www.megaupload.com/?d=" . $auxiliar, false, $context);
          if (preg_match('/location: (.+)/',$http_response_header[3],$res)) {
            $part = (sizeof($megaup[2]) > 1) ? "/" . ($i+1) : "";
            $retMediaItems[] = array (
              'id' => 'umsp://plugins/seriesyonkis?' . $auxiliar,
              'dc:title' => html_entity_decode($title[1],0,"UTF-8") . " (Megaupload #" . ($z+1) . $part . ")",
              'res' => $res[1],
              'upnp:class' => 'object.item.videoitem',
              'protocolInfo' => '*:*:*:*'
            );
          }
      }
      return $retMediaItems;
    }

    ?>